searchData={"items":[{"type":"module","title":"DiodeClient","doc":"[DiodeClient](https://github.com/diodechain/diode_client_ex) secure end-to-end encrypted connections between any two machines. Connections are established\neither through direct peer-to-peer TCP connections or bridged via the Diode network. To learn more about the\ndecentralized Diode network visit https://diode.io/\n\nExample Usage of [DiodeClient](https://github.com/diodechain/diode_client_ex) with a simple server:\n\n```elixir\nDiodeClient.interface_add(\"example_server_interface\")\naddress = DiodeClient.Base16.encode(DiodeClient.address())\n\n{:ok, port} = DiodeClient.port_listen(5000)\nspawn_link(fn ->\n  IO.puts(\"server #{address} started\")\n  {:ok, ssl} = DiodeClient.port_accept(port)\n  peer = DiodeClient.Port.peer(ssl)\n  IO.puts(\"got a connection from #{Base.encode16(peer)}\")\n  :ssl.controlling_process(ssl, self())\n  :ssl.setopts(ssl, [packet: :line, active: true])\n  for x <- 1..10 do\n    IO.puts(\"sending message #{x}\")\n    :ssl.send(ssl, \"Hello #{Base.encode16(peer)} this is message #{x}\\n\")\n  end\n  receive do\n    {:ssl_closed, _ssl} -> IO.puts(\"closed!\")\n  end\nend)\n\n```\n\nAnd the client. Here insert in the server address the address that has been printed above.\nFor example `server_address = \"0x389eba94b330140579cdce1feb1a6e905ff876e6\"`\n\n```elixir\n  # Client:\n  server_address = \"0x389eba94b330140579cdce1feb1a6e905ff876e6\"\n  DiodeClient.interface_add(\"example_client_interface\")\n\n  spawn_link(fn ->\n    {:ok, ssl} = DiodeClient.port_connect(server_address, 5000)\n    :ssl.controlling_process(ssl, self())\n    :ssl.setopts(ssl, [packet: :line, active: true])\n    Enum.reduce_while(1..10, nil, fn _, _ ->\n      receive do\n        {:ssl, _ssl, msg} -> {:cont, IO.inspect(msg)}\n        other -> {:halt, IO.inspect(other)}\n      end\n    end)\n    :ssl.close(ssl)\n    IO.puts(\"closed!\")\n  end)\n```","ref":"DiodeClient.html"},{"type":"function","title":"DiodeClient.address/0","doc":"","ref":"DiodeClient.html#address/0"},{"type":"function","title":"DiodeClient.fleet_address/0","doc":"","ref":"DiodeClient.html#fleet_address/0"},{"type":"function","title":"DiodeClient.interface_add/2","doc":"","ref":"DiodeClient.html#interface_add/2"},{"type":"function","title":"DiodeClient.interface_online?/1","doc":"","ref":"DiodeClient.html#interface_online?/1"},{"type":"function","title":"DiodeClient.interface_restart/1","doc":"","ref":"DiodeClient.html#interface_restart/1"},{"type":"function","title":"DiodeClient.interface_stop/1","doc":"","ref":"DiodeClient.html#interface_stop/1"},{"type":"function","title":"DiodeClient.port_accept/1","doc":"","ref":"DiodeClient.html#port_accept/1"},{"type":"function","title":"DiodeClient.port_close/1","doc":"","ref":"DiodeClient.html#port_close/1"},{"type":"function","title":"DiodeClient.port_connect/3","doc":"","ref":"DiodeClient.html#port_connect/3"},{"type":"function","title":"DiodeClient.port_listen/2","doc":"","ref":"DiodeClient.html#port_listen/2"},{"type":"function","title":"DiodeClient.shell_for_chain_id/1","doc":"","ref":"DiodeClient.html#shell_for_chain_id/1"},{"type":"module","title":"DiodeClient.BitMessage","doc":"BitMessage implementation used for Diode P2P cold messages.\n\n  Our storage is a bit more compact than the original BitMessage spec at:\n  https://wiki.bitmessage.org/index.php/Encryption\n\n  1. We're skipping \"Curve Type\" because we always use secp256k1\n  2. We always use the compact public key representation instead of full X and Y","ref":"DiodeClient.BitMessage.html"},{"type":"function","title":"DiodeClient.BitMessage.decrypt/2","doc":"","ref":"DiodeClient.BitMessage.html#decrypt/2"},{"type":"function","title":"DiodeClient.BitMessage.encrypt/2","doc":"","ref":"DiodeClient.BitMessage.html#encrypt/2"},{"type":"function","title":"DiodeClient.BitMessage.point_multiply/2","doc":"","ref":"DiodeClient.BitMessage.html#point_multiply/2"},{"type":"module","title":"DiodeClient.Block","doc":"Block related helper functions","ref":"DiodeClient.Block.html"},{"type":"function","title":"DiodeClient.Block.diode?/1","doc":"","ref":"DiodeClient.Block.html#diode?/1"},{"type":"function","title":"DiodeClient.Block.epoch/1","doc":"","ref":"DiodeClient.Block.html#epoch/1"},{"type":"function","title":"DiodeClient.Block.hash/1","doc":"","ref":"DiodeClient.Block.html#hash/1"},{"type":"function","title":"DiodeClient.Block.miner_signature/1","doc":"","ref":"DiodeClient.Block.html#miner_signature/1"},{"type":"function","title":"DiodeClient.Block.nano_timestamp/1","doc":"","ref":"DiodeClient.Block.html#nano_timestamp/1"},{"type":"function","title":"DiodeClient.Block.nonce/1","doc":"","ref":"DiodeClient.Block.html#nonce/1"},{"type":"function","title":"DiodeClient.Block.number/1","doc":"","ref":"DiodeClient.Block.html#number/1"},{"type":"function","title":"DiodeClient.Block.previous_block/1","doc":"","ref":"DiodeClient.Block.html#previous_block/1"},{"type":"function","title":"DiodeClient.Block.state_hash/1","doc":"","ref":"DiodeClient.Block.html#state_hash/1"},{"type":"function","title":"DiodeClient.Block.timestamp/1","doc":"","ref":"DiodeClient.Block.html#timestamp/1"},{"type":"function","title":"DiodeClient.Block.transaction_hash/1","doc":"","ref":"DiodeClient.Block.html#transaction_hash/1"},{"type":"module","title":"DiodeClient.Contracts.BNS","doc":"Wrapper for BNS smart contract to register and resolve names.","ref":"DiodeClient.Contracts.BNS.html"},{"type":"function","title":"DiodeClient.Contracts.BNS.is_bns/1","doc":"","ref":"DiodeClient.Contracts.BNS.html#is_bns/1"},{"type":"function","title":"DiodeClient.Contracts.BNS.name_to_shell/1","doc":"","ref":"DiodeClient.Contracts.BNS.html#name_to_shell/1"},{"type":"function","title":"DiodeClient.Contracts.BNS.register/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#register/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.register_multiple/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#register_multiple/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.register_reverse/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#register_reverse/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.resolve_address/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#resolve_address/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.resolve_name/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#resolve_name/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.resolve_name_all/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#resolve_name_all/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.resolve_name_owner/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#resolve_name_owner/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.resolve_name_owner_ext/2","doc":"","ref":"DiodeClient.Contracts.BNS.html#resolve_name_owner_ext/2"},{"type":"function","title":"DiodeClient.Contracts.BNS.unregister/1","doc":"","ref":"DiodeClient.Contracts.BNS.html#unregister/1"},{"type":"module","title":"DiodeClient.Contracts.CallPermit","doc":"Moonbeam CallPermit contract\n  https://github.com/moonbeam-foundation/moonbeam/blob/master/precompiles/call-permit/CallPermit.sol","ref":"DiodeClient.Contracts.CallPermit.html"},{"type":"function","title":"DiodeClient.Contracts.CallPermit.call_permit/8","doc":"","ref":"DiodeClient.Contracts.CallPermit.html#call_permit/8"},{"type":"function","title":"DiodeClient.Contracts.CallPermit.dispatch/7","doc":"","ref":"DiodeClient.Contracts.CallPermit.html#dispatch/7"},{"type":"function","title":"DiodeClient.Contracts.CallPermit.domain_separator/0","doc":"","ref":"DiodeClient.Contracts.CallPermit.html#domain_separator/0"},{"type":"function","title":"DiodeClient.Contracts.CallPermit.nonces/1","doc":"","ref":"DiodeClient.Contracts.CallPermit.html#nonces/1"},{"type":"module","title":"DiodeClient.Contracts.DiodeBNS","doc":"Location of the BNS smart contract on Diode Network.","ref":"DiodeClient.Contracts.DiodeBNS.html"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.address/2","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#address/2"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.is_bns/1","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#is_bns/1"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.number/2","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#number/2"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.shell/0","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#shell/0"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.storage_root/0","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#storage_root/0"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.string/2","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#string/2"},{"type":"function","title":"DiodeClient.Contracts.DiodeBNS.value/4","doc":"","ref":"DiodeClient.Contracts.DiodeBNS.html#value/4"},{"type":"module","title":"DiodeClient.Contracts.DriveMember","doc":"Imported contract to read group memberships. Useful to recursively resolve\nBNS names to individual devices.","ref":"DiodeClient.Contracts.DriveMember.html"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.add_drive/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#add_drive/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.add_member/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#add_member/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.addtl_drive_addresses/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#addtl_drive_addresses/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.drive_address/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#drive_address/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.member/4","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#member/4"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.members/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#members/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.owner/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#owner/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.owner?/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#owner?/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.proxy_factory/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#proxy_factory/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.proxy_target/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#proxy_target/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.remove_member/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#remove_member/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.root/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#root/3"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.submit_transaction/4","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#submit_transaction/4"},{"type":"function","title":"DiodeClient.Contracts.DriveMember.transfer_ownership/3","doc":"","ref":"DiodeClient.Contracts.DriveMember.html#transfer_ownership/3"},{"type":"module","title":"DiodeClient.Contracts.M1BNS","doc":"Location of the BNS smart contract on Moonbase Alpha.","ref":"DiodeClient.Contracts.M1BNS.html"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.address/2","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#address/2"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.is_bns/1","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#is_bns/1"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.number/2","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#number/2"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.send_transaction/3","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#send_transaction/3"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.shell/0","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#shell/0"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.storage_root/0","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#storage_root/0"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.string/2","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#string/2"},{"type":"function","title":"DiodeClient.Contracts.M1BNS.value/4","doc":"","ref":"DiodeClient.Contracts.M1BNS.html#value/4"},{"type":"module","title":"DiodeClient.EIP712","doc":"EIP-712 implementation","ref":"DiodeClient.EIP712.html"},{"type":"function","title":"DiodeClient.EIP712.encode/3","doc":"","ref":"DiodeClient.EIP712.html#encode/3"},{"type":"function","title":"DiodeClient.EIP712.encode/4","doc":"","ref":"DiodeClient.EIP712.html#encode/4"},{"type":"function","title":"DiodeClient.EIP712.encode_single_type/2","doc":"","ref":"DiodeClient.EIP712.html#encode_single_type/2"},{"type":"function","title":"DiodeClient.EIP712.encode_type/2","doc":"","ref":"DiodeClient.EIP712.html#encode_type/2"},{"type":"function","title":"DiodeClient.EIP712.hash_domain_separator/4","doc":"","ref":"DiodeClient.EIP712.html#hash_domain_separator/4"},{"type":"function","title":"DiodeClient.EIP712.hash_struct/2","doc":"","ref":"DiodeClient.EIP712.html#hash_struct/2"},{"type":"function","title":"DiodeClient.EIP712.hash_struct/3","doc":"","ref":"DiodeClient.EIP712.html#hash_struct/3"},{"type":"function","title":"DiodeClient.EIP712.type_hash/2","doc":"","ref":"DiodeClient.EIP712.html#type_hash/2"},{"type":"module","title":"DiodeClient.MetaTransaction","doc":"Meta transaction to submit pre-signed transactions to the blockchain.","ref":"DiodeClient.MetaTransaction.html"},{"type":"function","title":"DiodeClient.MetaTransaction.sign/2","doc":"","ref":"DiodeClient.MetaTransaction.html#sign/2"},{"type":"function","title":"DiodeClient.MetaTransaction.to_rlp/1","doc":"","ref":"DiodeClient.MetaTransaction.html#to_rlp/1"},{"type":"module","title":"DiodeClient.Rlp","doc":"Encoding and Decoding of Recursive Length Prefix (RLP) https://eth.wiki/fundamentals/rlp\n\n  RLP is easy to decode and encode and has only two types of data:\n  list() and binaries() for small binaries and lists there is\n  very space efficient encoding. But primarily it allows native\n  storing of binary data which is the main reason it's used within the\n  Diode Network.\n\n  By convention maps are stored like keyword lists in Erlang as a list of\n  key, value pairs such as:\n  `[[key1, value1], [key2, value2]]`\n\n  To ease working with maps they are automatically encoded to a keyword list\n  and there is the `Rlpx.list2map` to convert them back:\n\n  ```\n    iex> alias DiodeClient.{Rlp, Rlpx}\n    iex> Rlp.encode!(%{key: \"value\"})\n    <<203, 202, 131, 107, 101, 121, 133, 118, 97, 108, 117, 101>>\n    iex> Rlp.encode!(%{key: \"value\"}) |> Rlp.decode!()\n    [[\"key\", \"value\"]]\n    iex> Rlp.encode!(%{key: \"value\"}) |> Rlp.decode!()\n    [[\"key\", \"value\"]]\n    iex> Rlp.encode!(%{key: \"value\"}) |> Rlp.decode! |> Rlpx.list2map\n    %{\"key\" => \"value\"}\n  ```","ref":"DiodeClient.Rlp.html"},{"type":"function","title":"DiodeClient.Rlp.decode/1","doc":"","ref":"DiodeClient.Rlp.html#decode/1"},{"type":"function","title":"DiodeClient.Rlp.decode!/1","doc":"","ref":"DiodeClient.Rlp.html#decode!/1"},{"type":"function","title":"DiodeClient.Rlp.do_encode!/2","doc":"","ref":"DiodeClient.Rlp.html#do_encode!/2"},{"type":"function","title":"DiodeClient.Rlp.encode!/2","doc":"Encode an Elixir term to RLP. Integers are converted\n  to binaries using `:binary.encode_unsigned/1`\n\n  If you want to encode integers as signed values pass\n  `encode!(term, unsigned: false)`","ref":"DiodeClient.Rlp.html#encode!/2"},{"type":"function","title":"DiodeClient.Rlp.encode_to_iolist!/2","doc":"","ref":"DiodeClient.Rlp.html#encode_to_iolist!/2"},{"type":"function","title":"DiodeClient.Rlp.test_perf/0","doc":"","ref":"DiodeClient.Rlp.html#test_perf/0"},{"type":"type","title":"DiodeClient.Rlp.rlp/0","doc":"","ref":"DiodeClient.Rlp.html#t:rlp/0"},{"type":"module","title":"DiodeClient.Shell","doc":"DiodeClient.Shell is the interface to the blockchain state. It allows\nfetching accounts and block header information. Data fetched is by\ndefault checked against a merkle proof.\n\n# Example fetching smart contract state from an address\n\n```\nme = DiodeClient.address()\nDiodeClient.Shell.get_account(me)\n```","ref":"DiodeClient.Shell.html"},{"type":"function","title":"DiodeClient.Shell.await_all/1","doc":"","ref":"DiodeClient.Shell.html#await_all/1"},{"type":"function","title":"DiodeClient.Shell.blockexplorer_url/1","doc":"","ref":"DiodeClient.Shell.html#blockexplorer_url/1"},{"type":"function","title":"DiodeClient.Shell.cached_rpc/1","doc":"","ref":"DiodeClient.Shell.html#cached_rpc/1"},{"type":"function","title":"DiodeClient.Shell.chain_id/0","doc":"","ref":"DiodeClient.Shell.html#chain_id/0"},{"type":"function","title":"DiodeClient.Shell.create_transaction/5","doc":"","ref":"DiodeClient.Shell.html#create_transaction/5"},{"type":"function","title":"DiodeClient.Shell.ether/1","doc":"","ref":"DiodeClient.Shell.html#ether/1"},{"type":"function","title":"DiodeClient.Shell.finney/1","doc":"","ref":"DiodeClient.Shell.html#finney/1"},{"type":"function","title":"DiodeClient.Shell.get_account/2","doc":"","ref":"DiodeClient.Shell.html#get_account/2"},{"type":"function","title":"DiodeClient.Shell.get_account_root/2","doc":"","ref":"DiodeClient.Shell.html#get_account_root/2"},{"type":"function","title":"DiodeClient.Shell.get_account_roots/2","doc":"","ref":"DiodeClient.Shell.html#get_account_roots/2"},{"type":"function","title":"DiodeClient.Shell.get_account_value/3","doc":"","ref":"DiodeClient.Shell.html#get_account_value/3"},{"type":"function","title":"DiodeClient.Shell.get_account_values/3","doc":"","ref":"DiodeClient.Shell.html#get_account_values/3"},{"type":"function","title":"DiodeClient.Shell.get_block_header/1","doc":"","ref":"DiodeClient.Shell.html#get_block_header/1"},{"type":"function","title":"DiodeClient.Shell.get_node/1","doc":"","ref":"DiodeClient.Shell.html#get_node/1"},{"type":"function","title":"DiodeClient.Shell.get_object/1","doc":"","ref":"DiodeClient.Shell.html#get_object/1"},{"type":"function","title":"DiodeClient.Shell.get_state_roots/1","doc":"","ref":"DiodeClient.Shell.html#get_state_roots/1"},{"type":"function","title":"DiodeClient.Shell.gwei/1","doc":"","ref":"DiodeClient.Shell.html#gwei/1"},{"type":"function","title":"DiodeClient.Shell.kwei/1","doc":"","ref":"DiodeClient.Shell.html#kwei/1"},{"type":"function","title":"DiodeClient.Shell.mwei/1","doc":"","ref":"DiodeClient.Shell.html#mwei/1"},{"type":"function","title":"DiodeClient.Shell.peak/0","doc":"","ref":"DiodeClient.Shell.html#peak/0"},{"type":"function","title":"DiodeClient.Shell.peak_number/1","doc":"","ref":"DiodeClient.Shell.html#peak_number/1"},{"type":"function","title":"DiodeClient.Shell.prefix/0","doc":"","ref":"DiodeClient.Shell.html#prefix/0"},{"type":"function","title":"DiodeClient.Shell.rpc/1","doc":"","ref":"DiodeClient.Shell.html#rpc/1"},{"type":"function","title":"DiodeClient.Shell.send_transaction/1","doc":"","ref":"DiodeClient.Shell.html#send_transaction/1"},{"type":"function","title":"DiodeClient.Shell.send_transaction/5","doc":"","ref":"DiodeClient.Shell.html#send_transaction/5"},{"type":"function","title":"DiodeClient.Shell.szabo/1","doc":"","ref":"DiodeClient.Shell.html#szabo/1"},{"type":"function","title":"DiodeClient.Shell.uncache_rpc/1","doc":"","ref":"DiodeClient.Shell.html#uncache_rpc/1"},{"type":"function","title":"DiodeClient.Shell.wei/1","doc":"","ref":"DiodeClient.Shell.html#wei/1"},{"type":"module","title":"DiodeClient.Shell.MoonbaseAlpha","doc":"DiodeClient.Shell is the interface to the blockchain state. It allows\nfetching accounts and block header information. Data fetched is by\ndefault checked against a merkle proof.\n\n# Example fetching smart contract state from an address\n\n```\nme = DiodeClient.address()\nDiodeClient.Shell.get_account(me)\n```","ref":"DiodeClient.Shell.MoonbaseAlpha.html"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.blockexplorer_url/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#blockexplorer_url/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.cached_rpc/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#cached_rpc/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.chain_id/0","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#chain_id/0"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.create_meta_transaction/6","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#create_meta_transaction/6"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.create_transaction/5","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#create_transaction/5"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_account/2","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_account/2"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_account_root/2","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_account_root/2"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_account_value/3","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_account_value/3"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_account_values/3","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_account_values/3"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_block_header/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_block_header/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_meta_nonce/2","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_meta_nonce/2"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_node/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_node/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.get_object/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#get_object/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.peak/0","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#peak/0"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.peak_number/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#peak_number/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.prefix/0","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#prefix/0"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.rpc/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#rpc/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.send_transaction/1","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#send_transaction/1"},{"type":"function","title":"DiodeClient.Shell.MoonbaseAlpha.send_transaction/5","doc":"","ref":"DiodeClient.Shell.MoonbaseAlpha.html#send_transaction/5"},{"type":"module","title":"DiodeClient.Shell.Moonbeam","doc":"DiodeClient.Shell is the interface to the blockchain state. It allows\nfetching accounts and block header information. Data fetched is by\ndefault checked against a merkle proof.\n\n# Example fetching smart contract state from an address\n\n```\nme = DiodeClient.address()\nDiodeClient.Shell.get_account(me)\n```","ref":"DiodeClient.Shell.Moonbeam.html"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.blockexplorer_url/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#blockexplorer_url/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.cached_rpc/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#cached_rpc/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.chain_id/0","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#chain_id/0"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.create_meta_transaction/6","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#create_meta_transaction/6"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.create_transaction/5","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#create_transaction/5"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_account/2","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_account/2"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_account_root/2","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_account_root/2"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_account_value/3","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_account_value/3"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_account_values/3","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_account_values/3"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_block_header/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_block_header/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_meta_nonce/2","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_meta_nonce/2"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_node/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_node/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.get_object/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#get_object/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.peak/0","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#peak/0"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.peak_number/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#peak_number/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.prefix/0","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#prefix/0"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.rpc/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#rpc/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.send_transaction/1","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#send_transaction/1"},{"type":"function","title":"DiodeClient.Shell.Moonbeam.send_transaction/5","doc":"","ref":"DiodeClient.Shell.Moonbeam.html#send_transaction/5"},{"type":"module","title":"DiodeClient.Transport","doc":"DiodeClient Transport interface for use with Cowboy2 Adapter\nand `:hackeny`. Potentially more depending on interface compatibility\n\n# Example using hackney to make http requests via Diode:\n\n```\n{:ok, ref} = :hackney.connect(DiodeClient.Transport, address, port)\nrequest = {:get, path, [], \"\"}\n{:ok, status, headers, ^ref} = :hackney.send_request(ref, request)\n{:ok, content} = :hackney.body(ref)\n```","ref":"DiodeClient.Transport.html"},{"type":"function","title":"DiodeClient.Transport.accept/2","doc":"","ref":"DiodeClient.Transport.html#accept/2"},{"type":"function","title":"DiodeClient.Transport.close/1","doc":"","ref":"DiodeClient.Transport.html#close/1"},{"type":"function","title":"DiodeClient.Transport.connect/4","doc":"","ref":"DiodeClient.Transport.html#connect/4"},{"type":"function","title":"DiodeClient.Transport.controlling_process/2","doc":"","ref":"DiodeClient.Transport.html#controlling_process/2"},{"type":"function","title":"DiodeClient.Transport.getopts/2","doc":"","ref":"DiodeClient.Transport.html#getopts/2"},{"type":"function","title":"DiodeClient.Transport.handshake/3","doc":"","ref":"DiodeClient.Transport.html#handshake/3"},{"type":"function","title":"DiodeClient.Transport.listen/1","doc":"","ref":"DiodeClient.Transport.html#listen/1"},{"type":"function","title":"DiodeClient.Transport.messages/0","doc":"","ref":"DiodeClient.Transport.html#messages/0"},{"type":"function","title":"DiodeClient.Transport.messages/1","doc":"","ref":"DiodeClient.Transport.html#messages/1"},{"type":"function","title":"DiodeClient.Transport.name/0","doc":"","ref":"DiodeClient.Transport.html#name/0"},{"type":"function","title":"DiodeClient.Transport.peername/1","doc":"","ref":"DiodeClient.Transport.html#peername/1"},{"type":"function","title":"DiodeClient.Transport.recv/2","doc":"","ref":"DiodeClient.Transport.html#recv/2"},{"type":"function","title":"DiodeClient.Transport.recv/3","doc":"","ref":"DiodeClient.Transport.html#recv/3"},{"type":"function","title":"DiodeClient.Transport.secure/0","doc":"","ref":"DiodeClient.Transport.html#secure/0"},{"type":"function","title":"DiodeClient.Transport.send/2","doc":"","ref":"DiodeClient.Transport.html#send/2"},{"type":"function","title":"DiodeClient.Transport.sendfile/4","doc":"","ref":"DiodeClient.Transport.html#sendfile/4"},{"type":"function","title":"DiodeClient.Transport.setopts/2","doc":"","ref":"DiodeClient.Transport.html#setopts/2"},{"type":"function","title":"DiodeClient.Transport.shutdown/2","doc":"","ref":"DiodeClient.Transport.html#shutdown/2"},{"type":"function","title":"DiodeClient.Transport.sockname/1","doc":"","ref":"DiodeClient.Transport.html#sockname/1"},{"type":"module","title":"DiodeClient.Wallet","doc":"Representation of an Ethereum Wallet. This struct can hold keys in three levels\nof completeness\n\n1) Full key (including private key, public key and address)\n2) Public Key (including public key and address)\n3) Address (only the 20 byte Ethereum address)\n\nA wallet can be instantiated from any of those, but accessors for higher level components\nwill fail when the data is not available","ref":"DiodeClient.Wallet.html"},{"type":"function","title":"DiodeClient.Wallet.address/1","doc":"","ref":"DiodeClient.Wallet.html#address/1"},{"type":"function","title":"DiodeClient.Wallet.address!/1","doc":"","ref":"DiodeClient.Wallet.html#address!/1"},{"type":"function","title":"DiodeClient.Wallet.base16/1","doc":"","ref":"DiodeClient.Wallet.html#base16/1"},{"type":"function","title":"DiodeClient.Wallet.equal?/2","doc":"","ref":"DiodeClient.Wallet.html#equal?/2"},{"type":"function","title":"DiodeClient.Wallet.from_address/1","doc":"","ref":"DiodeClient.Wallet.html#from_address/1"},{"type":"function","title":"DiodeClient.Wallet.from_privkey/1","doc":"","ref":"DiodeClient.Wallet.html#from_privkey/1"},{"type":"function","title":"DiodeClient.Wallet.from_pubkey/1","doc":"","ref":"DiodeClient.Wallet.html#from_pubkey/1"},{"type":"function","title":"DiodeClient.Wallet.new/0","doc":"","ref":"DiodeClient.Wallet.html#new/0"},{"type":"function","title":"DiodeClient.Wallet.nick/1","doc":"","ref":"DiodeClient.Wallet.html#nick/1"},{"type":"function","title":"DiodeClient.Wallet.printable/1","doc":"","ref":"DiodeClient.Wallet.html#printable/1"},{"type":"function","title":"DiodeClient.Wallet.privkey/1","doc":"","ref":"DiodeClient.Wallet.html#privkey/1"},{"type":"function","title":"DiodeClient.Wallet.privkey!/1","doc":"","ref":"DiodeClient.Wallet.html#privkey!/1"},{"type":"function","title":"DiodeClient.Wallet.privkey?/1","doc":"","ref":"DiodeClient.Wallet.html#privkey?/1"},{"type":"function","title":"DiodeClient.Wallet.pubkey/1","doc":"","ref":"DiodeClient.Wallet.html#pubkey/1"},{"type":"function","title":"DiodeClient.Wallet.pubkey!/1","doc":"","ref":"DiodeClient.Wallet.html#pubkey!/1"},{"type":"function","title":"DiodeClient.Wallet.pubkey_long/1","doc":"","ref":"DiodeClient.Wallet.html#pubkey_long/1"},{"type":"function","title":"DiodeClient.Wallet.pubkey_long!/1","doc":"","ref":"DiodeClient.Wallet.html#pubkey_long!/1"},{"type":"macro","title":"DiodeClient.Wallet.wallet/1","doc":"","ref":"DiodeClient.Wallet.html#wallet/1"},{"type":"macro","title":"DiodeClient.Wallet.wallet/2","doc":"","ref":"DiodeClient.Wallet.html#wallet/2"},{"type":"type","title":"DiodeClient.Wallet.address/0","doc":"","ref":"DiodeClient.Wallet.html#t:address/0"},{"type":"type","title":"DiodeClient.Wallet.compressed_public_key/0","doc":"","ref":"DiodeClient.Wallet.html#t:compressed_public_key/0"},{"type":"type","title":"DiodeClient.Wallet.private_key/0","doc":"","ref":"DiodeClient.Wallet.html#t:private_key/0"},{"type":"type","title":"DiodeClient.Wallet.t/0","doc":"","ref":"DiodeClient.Wallet.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}